﻿
RealisticGlobalListener = {}

function RealisticGlobalListener:loadMap(name)
	
	--replace default vehicles of the 2 base maps
	if g_currentMission.missionInfo.vehiclesXMLLoad=="profileTemplate/careerVehicles_map01.xml" then --goldcrest valley
		g_currentMission.missionInfo.vehiclesXMLLoad = RealisticUtilsGP.mrGameplayDirectory .. "data/defaultVehicles/careerVehicles_map01.xml"
	elseif g_currentMission.missionInfo.vehiclesXMLLoad=="profileTemplate/careerVehicles_map02.xml" then --sosnovka
		g_currentMission.missionInfo.vehiclesXMLLoad = RealisticUtilsGP.mrGameplayDirectory .. "data/defaultVehicles/careerVehicles_map02.xml"
	end
	
	--RealisticUtilsGP.testClass("g_currentMission.missionInfo", g_currentMission.missionInfo)
	
	--modify the price of the fields of the 2 base maps
	-- could use "FieldDefinition.PRICE_HA_SCALE" or "FieldDefinition.PRICE_PER_HA" too
	if g_currentMission.missionInfo.mapXmlFilename=="data/maps/map01.xml" or g_currentMission.missionInfo.mapXmlFilename=="data/maps/map02.xml" then
		if g_currentMission.fieldDefinitionBase.numberOfFields and g_currentMission.fieldDefinitionBase.numberOfFields>0 then
			for i=1, g_currentMission.fieldDefinitionBase.numberOfFields do
				local field = g_currentMission.fieldDefinitionBase.fieldDefs[i]
				if field~=nil then
					--take into account the difficulty level (g_currentMission.missionInfo.difficulty==1 => easy, 2 => normal, 3 => hard)
					local diffFactor = 1 + 0.25*(g_currentMission.missionInfo.difficulty-1) -- 1 / 1.25 / 1.5
					local sizeFactor = 1 + 0.02*field.fieldArea  -- big field = more $$ per Ha since this is better/faster to take care compared to several small fields
					field.fieldPriceInitial = field.fieldArea * 40000 * diffFactor * sizeFactor
					--RealisticUtilsGP.testClass("field "..tostring(i), field)
				end
			end
		end
	end
		
end

function RealisticGlobalListener:deleteMap()    
end

function RealisticGlobalListener:mouseEvent(posX, posY, isDown, isUp, button)
end

function RealisticGlobalListener:keyEvent(unicode, sym, modifier, isDown)
end

function RealisticGlobalListener:update(dt)
end

function RealisticGlobalListener:draw()
end

addModEventListener(RealisticGlobalListener)